DEFDBL B-E
PRINT
PRINT "To convert the three-column data files *.cmb produced by COMBFILE.BAS"
PRINT "for one target and one projectile (one A1), relativistically "
PRINT "to be plotted similar to Sigmund's Fig.1 (Phys.Rev.36A(1997)3781)"
PRINT "but versus E/A, without adding log I ('Fano Plot')"
PRINT
'Note: the relativistic calculation of beta is correct down to EoverA=1E-7,
'if the projectile mass A1 is entered in u!

INPUT "Enter mass number and element symbol of projectile (e.g.,16, O): "; A1$, Proj$
A1 = VAL(A1$)

OPEN "Projs.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)                        'Find Z1
        INPUT #5, Z1, ProjList$
        IF Proj$ = ProjList$ THEN EXIT DO
        IF Z1 = 93 THEN PRINT "No projectile name found"
LOOP
CLOSE

OPEN "Masses.lst" FOR INPUT AS #6    'Rest Energies of Projectiles in MeV
INPUT #6, Heading$
DO WHILE NOT EOF(6)
         INPUT #6, Z1L, A1L, E0         'To find E0
         IF Z1L <> Z1 THEN GOTO there:
         IF A1L <> A1 THEN GOTO there:  ELSE EXIT DO
there:  LOOP
CLOSE #6

                                    'To find Z2:
INPUT "Enter element symbol of target (e.g., C, N2, etc.) : "; Targ$
OPEN "Targets.lst" FOR INPUT AS #5
DO WHILE NOT EOF(5)
        INPUT #5, Z2, TargList$
        IF Targ$ = TargList$ THEN EXIT DO
        IF Z2 = 140 THEN PRINT "No target name found"
LOOP
CLOSE

OPEN "atdata.txt" FOR INPUT AS #5        'Find A2
LINE INPUT #5, Heading$
LINE INPUT #5, Heading$
DO WHILE NOT EOF(5)
        INPUT #5, Z, C1, C2, A2, C3, C4  'Find rel. at. mass of natural element
        IF Z = Z2 THEN EXIT DO
LOOP

FileName$ = A1$ + Proj$ + Targ$
InFile$ = FileName$ + ".cmb"
OutFile$ = FileName$ + "L.2a"
OPEN InFile$ FOR INPUT AS #1
OPEN OutFile$ FOR OUTPUT AS #2

PRINT "     E           "; Proj$ + Targ$
PRINT #2, "     E           "; Proj$ + Targ$
DO WHILE NOT EOF(1)
        INPUT #1, EoverA, S, Letter$        'E/A in MeV,S in MeV/(mg/cm2)
'        VoverV0 = SQR(EoverA / .024802)     'V0^2/2 = 0.0248 MeV/u (non-rel.!)
'        Vred = VoverV0 / Z1
'        alpha = 1 / 137.036
'        beta = VoverV0 * alpha
        E = E0 + EoverA * A1                'Double Precision!
        beta = SQR(1 - (E0 / E) ^ 2)        'relativistic
'        VoverV0 = beta / alpha
        L = S * beta ^ 2 / (.000307075# * Z1 ^ 2 * Z2 / A2)  '.307075 MeVcm2/g, see Berger
'        Lred = L - LOG(4 * 13.606 * Z1 ^ 2 / I)  '2mV0^2 = 4*13.6 eV
        PRINT USING "###.#######  "; EoverA; L
        PRINT #2, USING "###.#######  "; EoverA; L
LOOP
END

